/* enhanced ECHO command.
see use.txt
Say! 1.6
Copyright: (c) 1993-2017 Roedy Green, Canadian Mind Products
#101 - 2536 Wark Street
Victoria, BC Canada V8T 4G8
tel:(250) 361-9093
mailto:roedyg@mindprod.com
http://mindprod.com
Compiled as a Windows console App, without precompiled headers.
For Visual C++ Express options see http://mindprod.com/jgloss/cpp.html#COMPILING
Version History:
 1.6 2010-01-28 port the DOS assembler version
*/
/* ==================================== */
#include <stdlib.h>  /* exit, putenv, _splitpath */
#include <stdio.h>   /* fclose, fgetc, printf, remove, rename, setvbuf */
/* ==================================== */
/* P R O T O T Y P E S */
int   atoiPlus ( const char* s );
void  banner(void);
int   main (int argc,  char *argv[]);
/* ==================================== */
int main(int argc, char *argv[])
{
	int i; /* local loop counter */
	int value; /* value of one of the fields */
	for (  i= 1; i<argc; i++ )
	{
		value =	atoiPlus( argv[i] );
		if ( value < 0 )
		{ printf ( argv[i] );}
		else
		{ putchar ( (char )value); }
	}
	return(0);
}
/* like atoi, but if not unsigned int, returns -1 */
int atoiPlus ( const char* s )
{
	int i = 0;
	char c;
	int result = 0;
	// empty string is not considered a number.
	if ( s[0]  == 0 )
	{
		return -1;
	}
	while ( (c = s[i]) != 0 )
	{
		if ( '0' <= c && c <= '9' )
		{
			result = result * 10  + c - '0';
		}
		else
		{
			return -1;
		}
		++i;
	}
	return result;
}
/* embedded display copyright banner, with shaded splashes. There is no possible syntax error to trigger it. */
void banner(void)
{
	printf("\n" "\xb0\xb1\xb2\xdb" " Say! 1.6 "  "\xdb\xb2\xb1\xb0"
		"\nFreeware enhanced ECHO command"
		"\nCopyright: (c) 1993-2017 Roedy Green, Canadian Mind Products"
		"\n" "#101 - 2536 Wark Street, Victoria, BC Canada V8T 4G8"
		"\n" "tel:(250) 361-9093   mailto:roedyg@mindprod.com   http://mindprod.com"
		"\n" "May be used freely for non-military use only"
		"\n\n");
}
/* -30- */
